#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#-----------------------------------------------------------------------------------------------------
# Name:         xmlDisp.py
# Purpose:      this module will display a xml file in a new Tkinter window.
#               there is a light syntax coloration spéific to the harl-ICPR2012
#               xml file format.
# Author:       Tristan Delizy
#-----------------------------------------------------------------------------------------------------


#====================================================================================================#
#IMPORTS
#====================================================================================================#
from Tkinter import *
import tkFileDialog
import tkMessageBox
import os, sys, re
import xml.etree.ElementTree as xml

#-----------------------------------------------------------------------------------------------------displayFile
#this function will create the new window and display the xml file.
def displayFile(filePath, parent):
    xml_file = file(filePath)
    xml_txt = xml_file.read()
    xml_file.close()

    createGui(parent, xml_txt)

#-----------------------------------------------------------------------------------------------------createGUI
#internal function to set up the interface
def createGui(parent, xml_txt):
    Gui_win = Toplevel(parent)
    Gui_win.geometry('500x500+500+50')

    bt_close = Button(Gui_win, text="close", command=Gui_win.destroy)
    txt_scrolly = Scrollbar(Gui_win)
    txt_area = Text(Gui_win, wrap=NONE, yscrollcommand=txt_scrolly.set)
    txt_area.insert(0.0, xml_txt)
    mkColor(txt_area)
    txt_area.config(state=DISABLED)
    txt_scrolly.config(command=txt_area.yview)

    txt_area.grid(row=0,column=0,sticky=N+S+E+W)
    txt_scrolly.grid(row=0,column=1, sticky=N+S)
    bt_close.grid(row=1,column=0,rowspan=2, )

    txt_area.update_idletasks()
    w = str(txt_area.winfo_width()+15)
    h = str(txt_area.winfo_height()+20)
    Gui_win.geometry(w+"x"+h+"+500+50")
    txt_scrolly.config(width=15)
    Gui_win.rowconfigure(0,weight=1)
    Gui_win.columnconfigure(0,weight=1)

#-----------------------------------------------------------------------------------------------------makeColor
#internal function to highlight key words
def mkColor(txt_w):
    i=0
    txt_w.config(state = NORMAL)
    txt_w.tag_configure("</>", foreground="#ff0000")
    txt_w.tag_configure("box", foreground="#000066")
    txt_w.tag_configure("act", foreground="#000088")
    txt_w.tag_configure("vid", foreground="#0000bb")
    txt_w.tag_configure("tag", foreground="#0000ff")

    start = 1.0
    while 1:
        pos1 = txt_w.search('<.', start, stopindex=END, regexp="true")
        if not pos1:
            break
        pos2 = txt_w.search('.>', pos1, stopindex=END, regexp="true")
        if not pos2 :
            break
        start = pos1 + "+1c"
        txt_w.tag_add("</>", pos1, pos1.split('.')[0]+"."+str(int(pos1.split('.')[1])+1))
        txt_w.tag_add("</>", pos2.split('.')[0]+"."+str(int(pos2.split('.')[1])+1),pos2.split('.')[0]+"."+str(int(pos2.split('.')[1])+2))
    start = 1.0
    while 1:
        pos1 = txt_w.search('/', start, stopindex=END, regexp="true")
        if not pos1:
            break
        start = pos1 + "+1c"
        txt_w.tag_add("</>", pos1, pos1.split('.')[0]+"."+str(int(pos1.split('.')[1])+1))
    start = 1.0
    while 1:
        pos1 = txt_w.search('bbox', start, stopindex=END, regexp="true")
        if not pos1:
            break
        start = pos1 + "+1c"
        txt_w.tag_add("box", pos1, pos1.split('.')[0]+"."+str(int(pos1.split('.')[1])+4))
    start = 1.0
    while 1:
        pos1 = txt_w.search('action', start, stopindex=END, regexp="true")
        if not pos1:
            break
        start = pos1 + "+1c"
        txt_w.tag_add("act", pos1, pos1.split('.')[0]+"."+str(int(pos1.split('.')[1])+6))
    start = 1.0
    while 1:
        pos1 = txt_w.search('video', start, stopindex=END, regexp="true")
        if not pos1:
            break
        start = pos1 + "+1c"
        txt_w.tag_add("vid", pos1, pos1.split('.')[0]+"."+str(int(pos1.split('.')[1])+5))
    start = 1.0
    while 1:
        pos1 = txt_w.search('tagset', start, stopindex=END, regexp="true")
        if not pos1:
            break
        start = pos1 + "+1c"
        txt_w.tag_add("tag", pos1, pos1.split('.')[0]+"."+str(int(pos1.split('.')[1])+6))

